#ifndef VIEWDLG_H
#define VIEWDLG_H

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\listbox.h>
#include <owl\groupbox.h>
#include "imagevw.h"



struct DecTransfer {
  UINT Res24But;
  UINT Res8But;
  UINT Res4But;
  UINT Rad1But;
  UINT Rad1DBut;
  UINT Scl1But;
  UINT Scl2But;
  UINT Scl4But;
  UINT Scl8But;
};

struct EncTransfer {
  UINT Res24But;
  UINT Res8But;
  UINT Res4But;
};

struct ComTransfer {
  char Cquality[4];
  char Csmooth[4];
};


class TDecDialog : public TDialog {

  public:
	 TDecDialog(TWindow* parent, DecTransfer* DecBuffer);
	 ~TDecDialog();

  protected:
	  TGroupBox* ResGrp;
	  TGroupBox* SclGrp;
	  TGroupBox* QGrp;
};

class TEncDialog : public TDialog {

  public:
	 TEncDialog(TWindow* parent, EncTransfer* EncBuffer);
	 ~TEncDialog();

  protected:
	  TGroupBox* ResGrp;
};

class TComDialog : public TDialog {

  public:
	 TComDialog(TWindow* parent, ComTransfer* ComBuffer);
	 ~TComDialog();

  protected:
};


class TGaugeDialog : public TDialog {

  public:
	 TGaugeDialog(TWindow* parent);
	 ~TGaugeDialog();
	 TGauge* Gauge;
	 short SetValue(int i);
	 short Cancel;
  protected:
	 void SetupWindow();
    void CmCancel();

  DECLARE_RESPONSE_TABLE(TGaugeDialog);
};

class TGauge2Dialog : public TDialog {

  public:
	 TGauge2Dialog(TWindow* parent);
	 ~TGauge2Dialog();
	 TGauge* Gauge;
	 short SetValue(int i);
  protected:
	 void SetupWindow();
};

#endif;
